module Text.HTML.Moe.Backend.ByteString where

import qualified Data.ByteString.Char8 as B
import Data.ByteString.UTF8 (fromString, toString)

type Internal = B.ByteString

pack :: String -> Internal
pack = fromString

unpack :: Internal -> String
unpack = toString

none :: Internal
none = B.empty

concat :: [Internal] -> Internal
concat = B.concat

append :: Internal -> Internal -> Internal
append = B.append

intercalate :: Internal -> [Internal] -> Internal
intercalate = B.intercalate

to_bs :: Internal -> B.ByteString
to_bs = id
