module Text.HTML.Moe2.Attribute where

import Text.HTML.Moe2.Type
import Text.HTML.Moe2.Utils
import Prelude hiding (id, (-))
import MPS.Light ((-))
import Text.HTML.Moe2.Utils

attr :: String -> String -> Attribute
attr x y = Attribute (pack x) (pack - escape - y)

_class      :: String -> Attribute
_data       :: String -> Attribute
_span       :: String -> Attribute
_style      :: String -> Attribute
_title      :: String -> Attribute
_type       :: String -> Attribute
action      :: String -> Attribute
align       :: String -> Attribute
alt         :: String -> Attribute
bgcolor     :: String -> Attribute
border      :: String -> Attribute
classid     :: String -> Attribute
colspan     :: String -> Attribute
cols        :: String -> Attribute
content     :: String -> Attribute
height      :: String -> Attribute
href        :: String -> Attribute
http_equiv  :: String -> Attribute
id          :: String -> Attribute
lang        :: String -> Attribute
language    :: String -> Attribute
media       :: String -> Attribute
method      :: String -> Attribute
name        :: String -> Attribute
quality     :: String -> Attribute
rel         :: String -> Attribute
rowspan     :: String -> Attribute
rows        :: String -> Attribute
selected    :: String -> Attribute
src         :: String -> Attribute
size        :: String -> Attribute
target      :: String -> Attribute
valign      :: String -> Attribute
value       :: String -> Attribute
width       :: String -> Attribute
xml_lang    :: String -> Attribute
xmlns       :: String -> Attribute

_class      = attr "class"
_data       = attr "data"
_span       = attr "span"
_style      = attr "style"
_title      = attr "title"
_type       = attr "type"
action      = attr "action"
align       = attr "align"
alt         = attr "alt"
bgcolor     = attr "bgcolor"
border      = attr "border"
classid     = attr "classid"
colspan     = attr "colspan"
cols        = attr "cols"
content     = attr "content"
height      = attr "height"
href        = attr "href"
http_equiv  = attr "http-equiv"
id          = attr "id"
lang        = attr "lang"
language    = attr "language"
media       = attr "media"
method      = attr "method"
name        = attr "name"
quality     = attr "quality"
rel         = attr "rel"
rowspan     = attr "rowspan"
rows        = attr "rows"
selected    = attr "selected"
src         = attr "src"
size        = attr "size"
target      = attr "target"
valign      = attr "valign"
value       = attr "value"
width       = attr "width"
xml_lang    = attr "xml:lang"
xmlns       = attr "xmlns"
